package u5a3;

import list.List;
import org.junit.Test;
import org.junit.Assert;
import u5a3.SortedLists;

public class Tests {
  
  
    private void check(List list, String expected) {
        Assert.assertEquals(expected, listToString(list));
    }
    
    private static String listToString(List list) {
        if (list == null) return "null";
        StringBuffer buf = new StringBuffer();
        buf.append(list.value).append(", ").append(listToString(list.next));
        return buf.toString();
    }
    
    private List create(int... values) {
        List list = null;
        for (int i = 0; i < values.length; i++) {
            list = new List(values[i], list);
        }
        return list;
    }
    private List checkInsertSorted(List list, int value, String expected) {
        List after = SortedLists.insertSorted(list, value);
        check(after, expected);
        return after;
    }

    @Test
    public void insertSorted1() {
        checkInsertSorted(null, 1, "1, null");
        checkInsertSorted(create(1), 2, "1, 2, null");
        checkInsertSorted(create(2), 1, "1, 2, null");
        checkInsertSorted(create(3, 1), 2, "1, 2, 3, null");
        checkInsertSorted(create(2, 1), 3, "1, 2, 3, null");
        checkInsertSorted(create(3, 2), 1, "1, 2, 3, null");
        checkInsertSorted(create(3, 2, 1), 2, "1, 2, 2, 3, null");
    }
    
    @Test
    public void insertSorted2() {
        List node = create(3, 2, 1);
        node = checkInsertSorted(node, 2, "1, 2, 2, 3, null");
        node = checkInsertSorted(node, 5, "1, 2, 2, 3, 5, null");
    }
    
    @Test
    public void insertSorted3() {
        List node = create(10000, 100, 1);
        node = checkInsertSorted(node, 200, "1, 100, 200, 10000, null");
        node = checkInsertSorted(node, 20000, "1, 100, 200, 10000, 20000, null");
    }

    private List checkSort(List list, String expected) {
        List after = SortedLists.sort(list);
        check(after, expected);
        return after;
    }

    @Test
    public void sort1() {
        checkSort(null, "null");
        checkSort(create(1), "1, null");
        checkSort(create(1, 2), "1, 2, null");
        checkSort(create(2, 1), "1, 2, null");
        checkSort(create(1, 2, 3), "1, 2, 3, null");
        checkSort(create(3, 2, 1), "1, 2, 3, null");
        checkSort(create(5, 3, 7, 9, 2), "2, 3, 5, 7, 9, null");
    }
    
    @Test
    public void sort2() {
        List node = create(1, 100, 10, 1000, 10000);
        node = checkSort(node, "1, 10, 100, 1000, 10000, null");
        node = new List(100000, node);
        node = checkSort(node, "1, 10, 100, 1000, 10000, 100000, null");
    }
    
    @Test
    public void sort3() {
        List node = create(1);
        node = checkSort(node, "1, null");
        node = checkSort(null, "null");
    }

}

